Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  abstract class TailCalls extends SubComponent with Transform

  Perform tail recursive call elimination.

  Perform tail recursive call elimination.

  Definition Classes
    transform
  Version

    1.0

-  class TailCallElimination extends Global.Transformer

  A Tail Call Transformer

  A Tail Call Transformer

  Definition Classes
    TailCalls
  Version

    1.1 What it does: Finds method calls in tail-position and replaces them with jumps. A call is in a tail-position if it is the last instruction to be executed in the body of a method. This is done by recursing over the trees that may contain calls in tail-position (trees that can't contain such calls are not transformed). However, they are not that many. Self-recursive calls in tail-position are replaced by jumps to a label at the beginning of the method. As the JVM provides no way to jump from a method to another one, non-recursive calls in tail-position are not optimized. A method call is self-recursive if it calls the current method and the method is final (otherwise, it could be a call to an overridden method in a subclass). Furthermore, If the method has type parameters, the call must contain these parameters as type arguments. Recursive calls on a different instance are optimized. Since 'this' is not a local variable, a dummy local val is added and used as a label parameter. The backend knows to load the corresponding argument in the 'this' (local at index 0). This dummy local is never used and should be cleaned up by dead code elimination (when enabled). This phase has been moved before pattern matching to catch more of the common cases of tail recursive functions. This means that more cases should be taken into account (like nested function, and pattern cases). If a method contains self-recursive calls, a label is added to at the beginning of its body and the calls are replaced by jumps to that label. Assumes: `Uncurry` has been run already, and no multiple parameter lists exist.

- ClonedTailContext
- DefDefTailContext
- EmptyTailContext
- TailContext

o

scala.tools.nsc.transform.TailCalls.TailCallElimination

# EmptyTailContext 

###

#### object EmptyTailContext extends TailContext

Source
  TailCalls.scala

Linear Supertypes
TailContext, AnyRef, Any
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. EmptyTailContext
2. TailContext
3. AnyRef
4. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
5.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
6.  def clonedTailContext(tailPos: Boolean): TailContext
   Attributes
     protected
   Definition Classes
     TailContext
7.  def enclosingType: Global.Type
   Definition Classes
     TailContext
8.  final def eq(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef
9.  def equals(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
10.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
11.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
12.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
13.  def isEligible: Boolean
    Definition Classes
      TailContext
14.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
15.  def isMandatory: Boolean
    Definition Classes
      TailContext
16.  def isTransformed: Boolean
    Definition Classes
      TailContext
17.  def label: Global.NoSymbol
    Definition Classes
      EmptyTailContext → TailContext
18.  def method: Global.NoSymbol
    Definition Classes
      EmptyTailContext → TailContext
19.  def methodPos: NoPosition.type
    Definition Classes
      EmptyTailContext → TailContext
20.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
21.  def newThis(pos: Global.Position): Global.TermSymbol
    Definition Classes
      TailContext
22.  final def noTailContext(): TailContext
    Definition Classes
      TailContext
23.  final def notify(): Unit
    Definition Classes
      AnyRef
24.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
25.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
26.  def tailLabels: Set[Global.Symbol]
    Definition Classes
      EmptyTailContext → TailContext
27.  def tailPos: Boolean
    Definition Classes
      EmptyTailContext → TailContext
28.  def toString(): String
    Definition Classes
      TailContext → AnyRef → Any
29.  def tparams: collection.immutable.Nil.type
    Definition Classes
      EmptyTailContext → TailContext
30.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
32.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
33.  final def yesTailContext(): TailContext
    Definition Classes
      TailContext

### Inherited from TailContext

### Inherited from AnyRef

### Inherited from Any

### Ungrouped